Package net.sf.saxon.expr.flwor

## Class ForClausePull

- java.lang.Object
- - net.sf.saxon.expr.flwor.TuplePull
  - - net.sf.saxon.expr.flwor.ForClausePull

- Direct Known Subclasses:
    `ForClauseOuterPull`

      public class ForClausePull
      extends TuplePull

  This class implements the changes to the tuple stream effected by a "for" clause in a FLWOR expression

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected TuplePull` | `base` |
    `protected FocusIterator` | `currentIteration` |
    `protected ForClause` | `forClause` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ForClausePull​(TuplePull base, ForClause forClause)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the tuple stream, indicating that although not all tuples have been read, no further tuples are required and resources can be released
    `boolean` | `nextTuple​(XPathContext context)` | Move on to the next tuple.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### base

          protected TuplePull base

    - #### forClause

          protected ForClause forClause

    - #### currentIteration

          protected FocusIterator currentIteration

  - ### Constructor Detail

    - #### ForClausePull

          public ForClausePull​(TuplePull base,
                               ForClause forClause)

  - ### Method Detail

    - #### nextTuple

          public boolean nextTuple​(XPathContext context)
                            throws XPathException

      Move on to the next tuple. Before returning, this method must set all the variables corresponding to the "returned" tuple in the local stack frame associated with the context object
      Specified by:
        `nextTuple` in class `TuplePull`
      Parameters:
        `context` - the dynamic evaluation context
      Returns:
        true if another tuple has been generated; false if the tuple stream is exhausted. If the method returns false, the values of the local variables corresponding to this tuple stream are undefined.
      Throws:
        `XPathException`

    - #### close

          public void close()

      Close the tuple stream, indicating that although not all tuples have been read, no further tuples are required and resources can be released
      Overrides:
        `close` in class `TuplePull`